// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: accelfin-server-demo-fx-dtos.proto

package com.accelfin.server.demo.fx.dtos;

/**
 * Protobuf type {@code com.accelfin.server.demo.fx.dtos.OrderDto}
 */
public  final class OrderDto extends
    com.google.protobuf.GeneratedMessage implements
    // @@protoc_insertion_point(message_implements:com.accelfin.server.demo.fx.dtos.OrderDto)
    OrderDtoOrBuilder {
  // Use OrderDto.newBuilder() to construct.
  private OrderDto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
    super(builder);
  }
  private OrderDto() {
    userName_ = "";
    orderId_ = "";
    currencyPair_ = "";
    side_ = 0;
    type_ = 0;
    status_ = 0;
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
  }
  private OrderDto(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    int mutable_bitField0_ = 0;
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!input.skipField(tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            java.lang.String s = input.readStringRequireUtf8();

            userName_ = s;
            break;
          }
          case 18: {
            java.lang.String s = input.readStringRequireUtf8();

            orderId_ = s;
            break;
          }
          case 26: {
            java.lang.String s = input.readStringRequireUtf8();

            currencyPair_ = s;
            break;
          }
          case 32: {
            int rawValue = input.readEnum();

            side_ = rawValue;
            break;
          }
          case 40: {
            int rawValue = input.readEnum();

            type_ = rawValue;
            break;
          }
          case 50: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (notional_ != null) {
              subBuilder = notional_.toBuilder();
            }
            notional_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(notional_);
              notional_ = subBuilder.buildPartial();
            }

            break;
          }
          case 58: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (submittedRate_ != null) {
              subBuilder = submittedRate_.toBuilder();
            }
            submittedRate_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(submittedRate_);
              submittedRate_ = subBuilder.buildPartial();
            }

            break;
          }
          case 66: {
            com.accelfin.server.messaging.dtos.TimestampDto.Builder subBuilder = null;
            if (submittedAt_ != null) {
              subBuilder = submittedAt_.toBuilder();
            }
            submittedAt_ = input.readMessage(com.accelfin.server.messaging.dtos.TimestampDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(submittedAt_);
              submittedAt_ = subBuilder.buildPartial();
            }

            break;
          }
          case 72: {
            int rawValue = input.readEnum();

            status_ = rawValue;
            break;
          }
          case 82: {
            com.accelfin.server.messaging.dtos.TimestampDto.Builder subBuilder = null;
            if (executedAt_ != null) {
              subBuilder = executedAt_.toBuilder();
            }
            executedAt_ = input.readMessage(com.accelfin.server.messaging.dtos.TimestampDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(executedAt_);
              executedAt_ = subBuilder.buildPartial();
            }

            break;
          }
          case 90: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (executedRate_ != null) {
              subBuilder = executedRate_.toBuilder();
            }
            executedRate_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(executedRate_);
              executedRate_ = subBuilder.buildPartial();
            }

            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderDto_descriptor;
  }

  protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderDto_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.accelfin.server.demo.fx.dtos.OrderDto.class, com.accelfin.server.demo.fx.dtos.OrderDto.Builder.class);
  }

  public static final int USER_NAME_FIELD_NUMBER = 1;
  private volatile java.lang.Object userName_;
  /**
   * <code>optional string user_name = 1;</code>
   */
  public java.lang.String getUserName() {
    java.lang.Object ref = userName_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      userName_ = s;
      return s;
    }
  }
  /**
   * <code>optional string user_name = 1;</code>
   */
  public com.google.protobuf.ByteString
      getUserNameBytes() {
    java.lang.Object ref = userName_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      userName_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int ORDER_ID_FIELD_NUMBER = 2;
  private volatile java.lang.Object orderId_;
  /**
   * <code>optional string order_id = 2;</code>
   */
  public java.lang.String getOrderId() {
    java.lang.Object ref = orderId_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      orderId_ = s;
      return s;
    }
  }
  /**
   * <code>optional string order_id = 2;</code>
   */
  public com.google.protobuf.ByteString
      getOrderIdBytes() {
    java.lang.Object ref = orderId_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      orderId_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int CURRENCY_PAIR_FIELD_NUMBER = 3;
  private volatile java.lang.Object currencyPair_;
  /**
   * <code>optional string currency_pair = 3;</code>
   */
  public java.lang.String getCurrencyPair() {
    java.lang.Object ref = currencyPair_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      currencyPair_ = s;
      return s;
    }
  }
  /**
   * <code>optional string currency_pair = 3;</code>
   */
  public com.google.protobuf.ByteString
      getCurrencyPairBytes() {
    java.lang.Object ref = currencyPair_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      currencyPair_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int SIDE_FIELD_NUMBER = 4;
  private int side_;
  /**
   * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
   */
  public int getSideValue() {
    return side_;
  }
  /**
   * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
   */
  public com.accelfin.server.demo.fx.dtos.SideDto getSide() {
    com.accelfin.server.demo.fx.dtos.SideDto result = com.accelfin.server.demo.fx.dtos.SideDto.forNumber(side_);
    return result == null ? com.accelfin.server.demo.fx.dtos.SideDto.UNRECOGNIZED : result;
  }

  public static final int TYPE_FIELD_NUMBER = 5;
  private int type_;
  /**
   * <code>optional .com.accelfin.server.demo.fx.dtos.OrderTypeDto type = 5;</code>
   */
  public int getTypeValue() {
    return type_;
  }
  /**
   * <code>optional .com.accelfin.server.demo.fx.dtos.OrderTypeDto type = 5;</code>
   */
  public com.accelfin.server.demo.fx.dtos.OrderTypeDto getType() {
    com.accelfin.server.demo.fx.dtos.OrderTypeDto result = com.accelfin.server.demo.fx.dtos.OrderTypeDto.forNumber(type_);
    return result == null ? com.accelfin.server.demo.fx.dtos.OrderTypeDto.UNRECOGNIZED : result;
  }

  public static final int NOTIONAL_FIELD_NUMBER = 6;
  private com.accelfin.server.messaging.dtos.DecimalDto notional_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 6;</code>
   */
  public boolean hasNotional() {
    return notional_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 6;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getNotional() {
    return notional_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : notional_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 6;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getNotionalOrBuilder() {
    return getNotional();
  }

  public static final int SUBMITTED_RATE_FIELD_NUMBER = 7;
  private com.accelfin.server.messaging.dtos.DecimalDto submittedRate_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto submitted_rate = 7;</code>
   */
  public boolean hasSubmittedRate() {
    return submittedRate_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto submitted_rate = 7;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getSubmittedRate() {
    return submittedRate_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : submittedRate_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto submitted_rate = 7;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getSubmittedRateOrBuilder() {
    return getSubmittedRate();
  }

  public static final int SUBMITTED_AT_FIELD_NUMBER = 8;
  private com.accelfin.server.messaging.dtos.TimestampDto submittedAt_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto submitted_at = 8;</code>
   */
  public boolean hasSubmittedAt() {
    return submittedAt_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto submitted_at = 8;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDto getSubmittedAt() {
    return submittedAt_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : submittedAt_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto submitted_at = 8;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getSubmittedAtOrBuilder() {
    return getSubmittedAt();
  }

  public static final int STATUS_FIELD_NUMBER = 9;
  private int status_;
  /**
   * <code>optional .com.accelfin.server.demo.fx.dtos.OrderStatusDto status = 9;</code>
   */
  public int getStatusValue() {
    return status_;
  }
  /**
   * <code>optional .com.accelfin.server.demo.fx.dtos.OrderStatusDto status = 9;</code>
   */
  public com.accelfin.server.demo.fx.dtos.OrderStatusDto getStatus() {
    com.accelfin.server.demo.fx.dtos.OrderStatusDto result = com.accelfin.server.demo.fx.dtos.OrderStatusDto.forNumber(status_);
    return result == null ? com.accelfin.server.demo.fx.dtos.OrderStatusDto.UNRECOGNIZED : result;
  }

  public static final int EXECUTED_AT_FIELD_NUMBER = 10;
  private com.accelfin.server.messaging.dtos.TimestampDto executedAt_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 10;</code>
   */
  public boolean hasExecutedAt() {
    return executedAt_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 10;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDto getExecutedAt() {
    return executedAt_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : executedAt_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 10;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getExecutedAtOrBuilder() {
    return getExecutedAt();
  }

  public static final int EXECUTED_RATE_FIELD_NUMBER = 11;
  private com.accelfin.server.messaging.dtos.DecimalDto executedRate_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 11;</code>
   */
  public boolean hasExecutedRate() {
    return executedRate_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 11;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getExecutedRate() {
    return executedRate_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : executedRate_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 11;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getExecutedRateOrBuilder() {
    return getExecutedRate();
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (!getUserNameBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessage.writeString(output, 1, userName_);
    }
    if (!getOrderIdBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessage.writeString(output, 2, orderId_);
    }
    if (!getCurrencyPairBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessage.writeString(output, 3, currencyPair_);
    }
    if (side_ != com.accelfin.server.demo.fx.dtos.SideDto.BUY.getNumber()) {
      output.writeEnum(4, side_);
    }
    if (type_ != com.accelfin.server.demo.fx.dtos.OrderTypeDto.TAKE_PROFIT.getNumber()) {
      output.writeEnum(5, type_);
    }
    if (notional_ != null) {
      output.writeMessage(6, getNotional());
    }
    if (submittedRate_ != null) {
      output.writeMessage(7, getSubmittedRate());
    }
    if (submittedAt_ != null) {
      output.writeMessage(8, getSubmittedAt());
    }
    if (status_ != com.accelfin.server.demo.fx.dtos.OrderStatusDto.ACTIVE.getNumber()) {
      output.writeEnum(9, status_);
    }
    if (executedAt_ != null) {
      output.writeMessage(10, getExecutedAt());
    }
    if (executedRate_ != null) {
      output.writeMessage(11, getExecutedRate());
    }
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!getUserNameBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessage.computeStringSize(1, userName_);
    }
    if (!getOrderIdBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessage.computeStringSize(2, orderId_);
    }
    if (!getCurrencyPairBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessage.computeStringSize(3, currencyPair_);
    }
    if (side_ != com.accelfin.server.demo.fx.dtos.SideDto.BUY.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(4, side_);
    }
    if (type_ != com.accelfin.server.demo.fx.dtos.OrderTypeDto.TAKE_PROFIT.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(5, type_);
    }
    if (notional_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getNotional());
    }
    if (submittedRate_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(7, getSubmittedRate());
    }
    if (submittedAt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(8, getSubmittedAt());
    }
    if (status_ != com.accelfin.server.demo.fx.dtos.OrderStatusDto.ACTIVE.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(9, status_);
    }
    if (executedAt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(10, getExecutedAt());
    }
    if (executedRate_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(11, getExecutedRate());
    }
    memoizedSize = size;
    return size;
  }

  private static final long serialVersionUID = 0L;
  public static com.accelfin.server.demo.fx.dtos.OrderDto parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderDto parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderDto parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderDto parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderDto parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderDto parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderDto parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderDto parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderDto parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderDto parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.accelfin.server.demo.fx.dtos.OrderDto prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessage.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code com.accelfin.server.demo.fx.dtos.OrderDto}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessage.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:com.accelfin.server.demo.fx.dtos.OrderDto)
      com.accelfin.server.demo.fx.dtos.OrderDtoOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderDto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderDto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.accelfin.server.demo.fx.dtos.OrderDto.class, com.accelfin.server.demo.fx.dtos.OrderDto.Builder.class);
    }

    // Construct using com.accelfin.server.demo.fx.dtos.OrderDto.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
      }
    }
    public Builder clear() {
      super.clear();
      userName_ = "";

      orderId_ = "";

      currencyPair_ = "";

      side_ = 0;

      type_ = 0;

      if (notionalBuilder_ == null) {
        notional_ = null;
      } else {
        notional_ = null;
        notionalBuilder_ = null;
      }
      if (submittedRateBuilder_ == null) {
        submittedRate_ = null;
      } else {
        submittedRate_ = null;
        submittedRateBuilder_ = null;
      }
      if (submittedAtBuilder_ == null) {
        submittedAt_ = null;
      } else {
        submittedAt_ = null;
        submittedAtBuilder_ = null;
      }
      status_ = 0;

      if (executedAtBuilder_ == null) {
        executedAt_ = null;
      } else {
        executedAt_ = null;
        executedAtBuilder_ = null;
      }
      if (executedRateBuilder_ == null) {
        executedRate_ = null;
      } else {
        executedRate_ = null;
        executedRateBuilder_ = null;
      }
      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderDto_descriptor;
    }

    public com.accelfin.server.demo.fx.dtos.OrderDto getDefaultInstanceForType() {
      return com.accelfin.server.demo.fx.dtos.OrderDto.getDefaultInstance();
    }

    public com.accelfin.server.demo.fx.dtos.OrderDto build() {
      com.accelfin.server.demo.fx.dtos.OrderDto result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public com.accelfin.server.demo.fx.dtos.OrderDto buildPartial() {
      com.accelfin.server.demo.fx.dtos.OrderDto result = new com.accelfin.server.demo.fx.dtos.OrderDto(this);
      result.userName_ = userName_;
      result.orderId_ = orderId_;
      result.currencyPair_ = currencyPair_;
      result.side_ = side_;
      result.type_ = type_;
      if (notionalBuilder_ == null) {
        result.notional_ = notional_;
      } else {
        result.notional_ = notionalBuilder_.build();
      }
      if (submittedRateBuilder_ == null) {
        result.submittedRate_ = submittedRate_;
      } else {
        result.submittedRate_ = submittedRateBuilder_.build();
      }
      if (submittedAtBuilder_ == null) {
        result.submittedAt_ = submittedAt_;
      } else {
        result.submittedAt_ = submittedAtBuilder_.build();
      }
      result.status_ = status_;
      if (executedAtBuilder_ == null) {
        result.executedAt_ = executedAt_;
      } else {
        result.executedAt_ = executedAtBuilder_.build();
      }
      if (executedRateBuilder_ == null) {
        result.executedRate_ = executedRate_;
      } else {
        result.executedRate_ = executedRateBuilder_.build();
      }
      onBuilt();
      return result;
    }

    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.accelfin.server.demo.fx.dtos.OrderDto) {
        return mergeFrom((com.accelfin.server.demo.fx.dtos.OrderDto)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.accelfin.server.demo.fx.dtos.OrderDto other) {
      if (other == com.accelfin.server.demo.fx.dtos.OrderDto.getDefaultInstance()) return this;
      if (!other.getUserName().isEmpty()) {
        userName_ = other.userName_;
        onChanged();
      }
      if (!other.getOrderId().isEmpty()) {
        orderId_ = other.orderId_;
        onChanged();
      }
      if (!other.getCurrencyPair().isEmpty()) {
        currencyPair_ = other.currencyPair_;
        onChanged();
      }
      if (other.side_ != 0) {
        setSideValue(other.getSideValue());
      }
      if (other.type_ != 0) {
        setTypeValue(other.getTypeValue());
      }
      if (other.hasNotional()) {
        mergeNotional(other.getNotional());
      }
      if (other.hasSubmittedRate()) {
        mergeSubmittedRate(other.getSubmittedRate());
      }
      if (other.hasSubmittedAt()) {
        mergeSubmittedAt(other.getSubmittedAt());
      }
      if (other.status_ != 0) {
        setStatusValue(other.getStatusValue());
      }
      if (other.hasExecutedAt()) {
        mergeExecutedAt(other.getExecutedAt());
      }
      if (other.hasExecutedRate()) {
        mergeExecutedRate(other.getExecutedRate());
      }
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      com.accelfin.server.demo.fx.dtos.OrderDto parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (com.accelfin.server.demo.fx.dtos.OrderDto) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private java.lang.Object userName_ = "";
    /**
     * <code>optional string user_name = 1;</code>
     */
    public java.lang.String getUserName() {
      java.lang.Object ref = userName_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        userName_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>optional string user_name = 1;</code>
     */
    public com.google.protobuf.ByteString
        getUserNameBytes() {
      java.lang.Object ref = userName_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        userName_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>optional string user_name = 1;</code>
     */
    public Builder setUserName(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      userName_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional string user_name = 1;</code>
     */
    public Builder clearUserName() {
      
      userName_ = getDefaultInstance().getUserName();
      onChanged();
      return this;
    }
    /**
     * <code>optional string user_name = 1;</code>
     */
    public Builder setUserNameBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      userName_ = value;
      onChanged();
      return this;
    }

    private java.lang.Object orderId_ = "";
    /**
     * <code>optional string order_id = 2;</code>
     */
    public java.lang.String getOrderId() {
      java.lang.Object ref = orderId_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        orderId_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>optional string order_id = 2;</code>
     */
    public com.google.protobuf.ByteString
        getOrderIdBytes() {
      java.lang.Object ref = orderId_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        orderId_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>optional string order_id = 2;</code>
     */
    public Builder setOrderId(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      orderId_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional string order_id = 2;</code>
     */
    public Builder clearOrderId() {
      
      orderId_ = getDefaultInstance().getOrderId();
      onChanged();
      return this;
    }
    /**
     * <code>optional string order_id = 2;</code>
     */
    public Builder setOrderIdBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      orderId_ = value;
      onChanged();
      return this;
    }

    private java.lang.Object currencyPair_ = "";
    /**
     * <code>optional string currency_pair = 3;</code>
     */
    public java.lang.String getCurrencyPair() {
      java.lang.Object ref = currencyPair_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        currencyPair_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>optional string currency_pair = 3;</code>
     */
    public com.google.protobuf.ByteString
        getCurrencyPairBytes() {
      java.lang.Object ref = currencyPair_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        currencyPair_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>optional string currency_pair = 3;</code>
     */
    public Builder setCurrencyPair(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      currencyPair_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional string currency_pair = 3;</code>
     */
    public Builder clearCurrencyPair() {
      
      currencyPair_ = getDefaultInstance().getCurrencyPair();
      onChanged();
      return this;
    }
    /**
     * <code>optional string currency_pair = 3;</code>
     */
    public Builder setCurrencyPairBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      currencyPair_ = value;
      onChanged();
      return this;
    }

    private int side_ = 0;
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
     */
    public int getSideValue() {
      return side_;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
     */
    public Builder setSideValue(int value) {
      side_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
     */
    public com.accelfin.server.demo.fx.dtos.SideDto getSide() {
      com.accelfin.server.demo.fx.dtos.SideDto result = com.accelfin.server.demo.fx.dtos.SideDto.forNumber(side_);
      return result == null ? com.accelfin.server.demo.fx.dtos.SideDto.UNRECOGNIZED : result;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
     */
    public Builder setSide(com.accelfin.server.demo.fx.dtos.SideDto value) {
      if (value == null) {
        throw new NullPointerException();
      }
      
      side_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
     */
    public Builder clearSide() {
      
      side_ = 0;
      onChanged();
      return this;
    }

    private int type_ = 0;
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderTypeDto type = 5;</code>
     */
    public int getTypeValue() {
      return type_;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderTypeDto type = 5;</code>
     */
    public Builder setTypeValue(int value) {
      type_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderTypeDto type = 5;</code>
     */
    public com.accelfin.server.demo.fx.dtos.OrderTypeDto getType() {
      com.accelfin.server.demo.fx.dtos.OrderTypeDto result = com.accelfin.server.demo.fx.dtos.OrderTypeDto.forNumber(type_);
      return result == null ? com.accelfin.server.demo.fx.dtos.OrderTypeDto.UNRECOGNIZED : result;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderTypeDto type = 5;</code>
     */
    public Builder setType(com.accelfin.server.demo.fx.dtos.OrderTypeDto value) {
      if (value == null) {
        throw new NullPointerException();
      }
      
      type_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderTypeDto type = 5;</code>
     */
    public Builder clearType() {
      
      type_ = 0;
      onChanged();
      return this;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto notional_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> notionalBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 6;</code>
     */
    public boolean hasNotional() {
      return notionalBuilder_ != null || notional_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 6;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getNotional() {
      if (notionalBuilder_ == null) {
        return notional_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : notional_;
      } else {
        return notionalBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 6;</code>
     */
    public Builder setNotional(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (notionalBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        notional_ = value;
        onChanged();
      } else {
        notionalBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 6;</code>
     */
    public Builder setNotional(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (notionalBuilder_ == null) {
        notional_ = builderForValue.build();
        onChanged();
      } else {
        notionalBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 6;</code>
     */
    public Builder mergeNotional(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (notionalBuilder_ == null) {
        if (notional_ != null) {
          notional_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(notional_).mergeFrom(value).buildPartial();
        } else {
          notional_ = value;
        }
        onChanged();
      } else {
        notionalBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 6;</code>
     */
    public Builder clearNotional() {
      if (notionalBuilder_ == null) {
        notional_ = null;
        onChanged();
      } else {
        notional_ = null;
        notionalBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 6;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getNotionalBuilder() {
      
      onChanged();
      return getNotionalFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 6;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getNotionalOrBuilder() {
      if (notionalBuilder_ != null) {
        return notionalBuilder_.getMessageOrBuilder();
      } else {
        return notional_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : notional_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 6;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getNotionalFieldBuilder() {
      if (notionalBuilder_ == null) {
        notionalBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getNotional(),
                getParentForChildren(),
                isClean());
        notional_ = null;
      }
      return notionalBuilder_;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto submittedRate_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> submittedRateBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto submitted_rate = 7;</code>
     */
    public boolean hasSubmittedRate() {
      return submittedRateBuilder_ != null || submittedRate_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto submitted_rate = 7;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getSubmittedRate() {
      if (submittedRateBuilder_ == null) {
        return submittedRate_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : submittedRate_;
      } else {
        return submittedRateBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto submitted_rate = 7;</code>
     */
    public Builder setSubmittedRate(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (submittedRateBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        submittedRate_ = value;
        onChanged();
      } else {
        submittedRateBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto submitted_rate = 7;</code>
     */
    public Builder setSubmittedRate(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (submittedRateBuilder_ == null) {
        submittedRate_ = builderForValue.build();
        onChanged();
      } else {
        submittedRateBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto submitted_rate = 7;</code>
     */
    public Builder mergeSubmittedRate(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (submittedRateBuilder_ == null) {
        if (submittedRate_ != null) {
          submittedRate_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(submittedRate_).mergeFrom(value).buildPartial();
        } else {
          submittedRate_ = value;
        }
        onChanged();
      } else {
        submittedRateBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto submitted_rate = 7;</code>
     */
    public Builder clearSubmittedRate() {
      if (submittedRateBuilder_ == null) {
        submittedRate_ = null;
        onChanged();
      } else {
        submittedRate_ = null;
        submittedRateBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto submitted_rate = 7;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getSubmittedRateBuilder() {
      
      onChanged();
      return getSubmittedRateFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto submitted_rate = 7;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getSubmittedRateOrBuilder() {
      if (submittedRateBuilder_ != null) {
        return submittedRateBuilder_.getMessageOrBuilder();
      } else {
        return submittedRate_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : submittedRate_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto submitted_rate = 7;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getSubmittedRateFieldBuilder() {
      if (submittedRateBuilder_ == null) {
        submittedRateBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getSubmittedRate(),
                getParentForChildren(),
                isClean());
        submittedRate_ = null;
      }
      return submittedRateBuilder_;
    }

    private com.accelfin.server.messaging.dtos.TimestampDto submittedAt_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> submittedAtBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto submitted_at = 8;</code>
     */
    public boolean hasSubmittedAt() {
      return submittedAtBuilder_ != null || submittedAt_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto submitted_at = 8;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto getSubmittedAt() {
      if (submittedAtBuilder_ == null) {
        return submittedAt_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : submittedAt_;
      } else {
        return submittedAtBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto submitted_at = 8;</code>
     */
    public Builder setSubmittedAt(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (submittedAtBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        submittedAt_ = value;
        onChanged();
      } else {
        submittedAtBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto submitted_at = 8;</code>
     */
    public Builder setSubmittedAt(
        com.accelfin.server.messaging.dtos.TimestampDto.Builder builderForValue) {
      if (submittedAtBuilder_ == null) {
        submittedAt_ = builderForValue.build();
        onChanged();
      } else {
        submittedAtBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto submitted_at = 8;</code>
     */
    public Builder mergeSubmittedAt(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (submittedAtBuilder_ == null) {
        if (submittedAt_ != null) {
          submittedAt_ =
            com.accelfin.server.messaging.dtos.TimestampDto.newBuilder(submittedAt_).mergeFrom(value).buildPartial();
        } else {
          submittedAt_ = value;
        }
        onChanged();
      } else {
        submittedAtBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto submitted_at = 8;</code>
     */
    public Builder clearSubmittedAt() {
      if (submittedAtBuilder_ == null) {
        submittedAt_ = null;
        onChanged();
      } else {
        submittedAt_ = null;
        submittedAtBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto submitted_at = 8;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto.Builder getSubmittedAtBuilder() {
      
      onChanged();
      return getSubmittedAtFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto submitted_at = 8;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getSubmittedAtOrBuilder() {
      if (submittedAtBuilder_ != null) {
        return submittedAtBuilder_.getMessageOrBuilder();
      } else {
        return submittedAt_ == null ?
            com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : submittedAt_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto submitted_at = 8;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> 
        getSubmittedAtFieldBuilder() {
      if (submittedAtBuilder_ == null) {
        submittedAtBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder>(
                getSubmittedAt(),
                getParentForChildren(),
                isClean());
        submittedAt_ = null;
      }
      return submittedAtBuilder_;
    }

    private int status_ = 0;
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderStatusDto status = 9;</code>
     */
    public int getStatusValue() {
      return status_;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderStatusDto status = 9;</code>
     */
    public Builder setStatusValue(int value) {
      status_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderStatusDto status = 9;</code>
     */
    public com.accelfin.server.demo.fx.dtos.OrderStatusDto getStatus() {
      com.accelfin.server.demo.fx.dtos.OrderStatusDto result = com.accelfin.server.demo.fx.dtos.OrderStatusDto.forNumber(status_);
      return result == null ? com.accelfin.server.demo.fx.dtos.OrderStatusDto.UNRECOGNIZED : result;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderStatusDto status = 9;</code>
     */
    public Builder setStatus(com.accelfin.server.demo.fx.dtos.OrderStatusDto value) {
      if (value == null) {
        throw new NullPointerException();
      }
      
      status_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderStatusDto status = 9;</code>
     */
    public Builder clearStatus() {
      
      status_ = 0;
      onChanged();
      return this;
    }

    private com.accelfin.server.messaging.dtos.TimestampDto executedAt_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> executedAtBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 10;</code>
     */
    public boolean hasExecutedAt() {
      return executedAtBuilder_ != null || executedAt_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 10;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto getExecutedAt() {
      if (executedAtBuilder_ == null) {
        return executedAt_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : executedAt_;
      } else {
        return executedAtBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 10;</code>
     */
    public Builder setExecutedAt(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (executedAtBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        executedAt_ = value;
        onChanged();
      } else {
        executedAtBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 10;</code>
     */
    public Builder setExecutedAt(
        com.accelfin.server.messaging.dtos.TimestampDto.Builder builderForValue) {
      if (executedAtBuilder_ == null) {
        executedAt_ = builderForValue.build();
        onChanged();
      } else {
        executedAtBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 10;</code>
     */
    public Builder mergeExecutedAt(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (executedAtBuilder_ == null) {
        if (executedAt_ != null) {
          executedAt_ =
            com.accelfin.server.messaging.dtos.TimestampDto.newBuilder(executedAt_).mergeFrom(value).buildPartial();
        } else {
          executedAt_ = value;
        }
        onChanged();
      } else {
        executedAtBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 10;</code>
     */
    public Builder clearExecutedAt() {
      if (executedAtBuilder_ == null) {
        executedAt_ = null;
        onChanged();
      } else {
        executedAt_ = null;
        executedAtBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 10;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto.Builder getExecutedAtBuilder() {
      
      onChanged();
      return getExecutedAtFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 10;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getExecutedAtOrBuilder() {
      if (executedAtBuilder_ != null) {
        return executedAtBuilder_.getMessageOrBuilder();
      } else {
        return executedAt_ == null ?
            com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : executedAt_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 10;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> 
        getExecutedAtFieldBuilder() {
      if (executedAtBuilder_ == null) {
        executedAtBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder>(
                getExecutedAt(),
                getParentForChildren(),
                isClean());
        executedAt_ = null;
      }
      return executedAtBuilder_;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto executedRate_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> executedRateBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 11;</code>
     */
    public boolean hasExecutedRate() {
      return executedRateBuilder_ != null || executedRate_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 11;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getExecutedRate() {
      if (executedRateBuilder_ == null) {
        return executedRate_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : executedRate_;
      } else {
        return executedRateBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 11;</code>
     */
    public Builder setExecutedRate(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (executedRateBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        executedRate_ = value;
        onChanged();
      } else {
        executedRateBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 11;</code>
     */
    public Builder setExecutedRate(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (executedRateBuilder_ == null) {
        executedRate_ = builderForValue.build();
        onChanged();
      } else {
        executedRateBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 11;</code>
     */
    public Builder mergeExecutedRate(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (executedRateBuilder_ == null) {
        if (executedRate_ != null) {
          executedRate_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(executedRate_).mergeFrom(value).buildPartial();
        } else {
          executedRate_ = value;
        }
        onChanged();
      } else {
        executedRateBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 11;</code>
     */
    public Builder clearExecutedRate() {
      if (executedRateBuilder_ == null) {
        executedRate_ = null;
        onChanged();
      } else {
        executedRate_ = null;
        executedRateBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 11;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getExecutedRateBuilder() {
      
      onChanged();
      return getExecutedRateFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 11;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getExecutedRateOrBuilder() {
      if (executedRateBuilder_ != null) {
        return executedRateBuilder_.getMessageOrBuilder();
      } else {
        return executedRate_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : executedRate_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 11;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getExecutedRateFieldBuilder() {
      if (executedRateBuilder_ == null) {
        executedRateBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getExecutedRate(),
                getParentForChildren(),
                isClean());
        executedRate_ = null;
      }
      return executedRateBuilder_;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }


    // @@protoc_insertion_point(builder_scope:com.accelfin.server.demo.fx.dtos.OrderDto)
  }

  // @@protoc_insertion_point(class_scope:com.accelfin.server.demo.fx.dtos.OrderDto)
  private static final com.accelfin.server.demo.fx.dtos.OrderDto DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.accelfin.server.demo.fx.dtos.OrderDto();
  }

  public static com.accelfin.server.demo.fx.dtos.OrderDto getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<OrderDto>
      PARSER = new com.google.protobuf.AbstractParser<OrderDto>() {
    public OrderDto parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
        return new OrderDto(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<OrderDto> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<OrderDto> getParserForType() {
    return PARSER;
  }

  public com.accelfin.server.demo.fx.dtos.OrderDto getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

